# -*- coding: utf-8 -*-
"""
Copyright (c) 2017-2021, Niklas Löcherer, Professorship for Audio Information Processing, Technical University of Munich, Germany. 

This work is licensed under a Creative Commons Attribution 4.0 International (CC BY 4.0) License, see https://creativecommons.org/licenses/by/4.0/ for more information. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

import argparse
import math
import re
import numpy as np
import time

from pythonosc import udp_client


if __name__ == "__main__":
    # Open UDP Configuration
    parser = argparse.ArgumentParser()
    parser.add_argument("--ip", default='127.0.0.1')
    parser.add_argument("--port", type=int, default=40000)
    args, unknown = parser.parse_known_args()

    rt_sofe_client = udp_client.SimpleUDPClient(args.ip, args.port)

    
    while True:
        user_input = input("Please enter a command followed by a list of arguments >>> ")
        if user_input == 'exit':
            break
        
        user_input = user_input.split(" ")
        
        command = user_input[0]
        args = user_input[1:]
        
        for i in range(len(args)):
            string = args[i]
            try:
                args[i] = float(string)
                args[i] = int(string)
            except ValueError:
                if string.lower() == 'false':
                    args[i] = 0
                elif string.lower() == 'true':
                    args[i] = 1
                continue
        
        rt_sofe_client.send_message(command, args)
